Index: trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp	(revision 490)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp	(revision 492)
@@ -49,6 +49,6 @@
 bool
 Environment::CheckForSwitch(const int argc,
-			     const char *argv[],
-			     const char swtch) const
+							char **argv,
+							const char swtch) const
 {
   for (int i = 1; i < argc; i++)
@@ -130,6 +130,6 @@
 void
 Environment::ReadCmdlineParams(const int argc,
-				const char *argv[],
-				const char *optParams)
+							   char **argv,
+							   const char *optParams)
 {
   int i;
@@ -619,6 +619,6 @@
 void
 Environment::ParseCmdline(const int argc,
-			   const char *argv[],
-			   const int index)
+						  char **argv,
+						  const int index)
 {
   int curIndex = -1;
@@ -1064,47 +1064,47 @@
 
   RegisterOption("Scene.filename",
-		 optString,
-		 "-scene_filename=",
-		 "atlanta2.x3d");
+				 optString,
+				 "scene_filename=",
+				 "atlanta2.x3d");
 
   RegisterOption("Unigraphics.meshGrouping",
-		 optInt,
-		 "-unigraphics_mesh_grouping=",
-		 "0");
+				 optInt,
+				 "unigraphics_mesh_grouping=",
+				 "0");
   
 
   RegisterOption("KdTree.Termination.minCost",
-		 optInt,
-		 "-kd_term_min_cost=",
-		 "10");
+				 optInt,
+				 "kd_term_min_cost=",
+				 "10");
   
   RegisterOption("KdTree.Termination.maxDepth",
-		 optInt,
-		 "-kd_term_max_depth=",
-		 "20");
+				 optInt,
+				 "kd_term_max_depth=",
+				 "20");
 
   RegisterOption("KdTree.Termination.maxCostRatio",
-		 optFloat,
-		 "-kd_term_max_cost_ratio=",
-		 "1.5");
+				 optFloat,
+				 "kd_term_max_cost_ratio=",
+				 "1.5");
 
   RegisterOption("KdTree.Termination.ct_div_ci",
-		 optFloat,
-		 "-kd_term_ct_div_ci=",
-		 "1.0");
+				 optFloat,
+				 "kd_term_ct_div_ci=",
+				 "1.0");
 
   RegisterOption("KdTree.splitMethod",
-		 optString,
-		 "-kd_split_method=",
-		 "spatialMedian");
+				 optString,
+				 "kd_split_method=",
+				 "spatialMedian");
 
   RegisterOption("KdTree.splitBorder",
 		 optFloat,
-		 "-kd_split_border=",
+		 "kd_split_border=",
 		 "0.1");
 
   RegisterOption("KdTree.sahUseFaces",
 		 optBool,
-		 "-kd_sah_use_faces=",
+		 "kd_sah_use_faces=",
 		 "true");
 
@@ -1112,67 +1112,68 @@
   RegisterOption("MeshKdTree.Termination.minCost",
 		 optInt,
-		 "-kd_term_min_cost=",
+		 "kd_term_min_cost=",
 		 "10");
   
   RegisterOption("MeshKdTree.Termination.maxDepth",
 		 optInt,
-		 "-kd_term_max_depth=",
+		 "kd_term_max_depth=",
 		 "20");
 
   RegisterOption("MeshKdTree.Termination.maxCostRatio",
 		 optFloat,
-		 "-kd_term_max_cost_ratio=",
+		 "kd_term_max_cost_ratio=",
 		 "1.5");
 
   RegisterOption("MeshKdTree.Termination.ct_div_ci",
 		 optFloat,
-		 "-kd_term_ct_div_ci=",
+		 "kd_term_ct_div_ci=",
 		 "1.0");
 
   RegisterOption("MeshKdTree.splitMethod",
 		 optString,
-		 "-kd_split_method=",
+		 "kd_split_method=",
 		 "spatialMedian");
 
   RegisterOption("MeshKdTree.splitBorder",
 		 optFloat,
-		 "-kd_split_border=",
+		 "kd_split_border=",
 		 "0.1");
 
   RegisterOption("Sampling.totalSamples",
 		 optInt,
-		 "-total_samples=",
+		 "total_samples=",
 		 "1000000");
 
   RegisterOption("Sampling.samplesPerPass",
 		 optInt,
-		 "-samples_per_pass=",
+		 "samples_per_pass=",
 		 "10");
 
   RegisterOption("VssPreprocessor.initialSamples",
-	  optInt,
-	  "-initial_samples=",
-	  "100000");
-
+				 optInt,
+				 "initial_samples=",
+				 "100000");
+  
   RegisterOption("VssPreprocessor.vssSamples",
-	  optInt,
-	  "-vss_samples=",
-	  "1000000");
+				 optInt,
+				 "vss_samples=",
+				 "1000000");
 	
   RegisterOption("VssPreprocessor.vssSamplesPerPass",
-	  optInt,
-	  "-vss_samples_per_pass=",
-	  "1000");
-
+				 optInt,
+				 "vss_samples_per_pass=",
+				 "1000");
+  
   RegisterOption("VssPreprocessor.samplesPerPass",
-	  optInt,
-	  "-samples_per_pass=",								
-	  "100000");
+				 optInt,
+				 "samples_per_pass=",
+				 "100000");
+
 
 
   RegisterOption("VssPreprocessor.useImportanceSampling",
-	  optBool,
-	  "-vss_use_importance=",
-	  "true");
+				 optBool,
+				 "vss_use_importance=",
+				 "true");
 
    RegisterOption("VssPreprocessor.loadInitialSamples",
@@ -1194,56 +1195,56 @@
   RegisterOption("ViewCells.type",
 		 optString,
-		 "-view_cells_type",
+		 "view_cells_type",
 		 "bspTree");
 
   RegisterOption("ViewCells.PostProcess.samples",
-	  optInt,
-	  "-view_cells_postprocess_samples=",
-	  "200000");
-
+				 optInt,
+				 "view_cells_postprocess_samples=",
+				 "200000");
+  
   RegisterOption("ViewCells.Visualization.samples",
-	  optInt,
-	  "-view_cells_visualization_samples=",
-	  "20000");
-
+				 optInt,
+				 "view_cells_visualization_samples=",
+				 "20000");
+  
    RegisterOption("ViewCells.loadFromFile",
-		 optBool,
-		 "-view_cells_load_from_file",
-		 "false");
-
+				  optBool,
+				  "view_cells_load_from_file",
+				  "false");
+   
   RegisterOption("ViewCells.maxViewCells",
 		 optInt,
-		 "-view_cells_max_view_cells",
+		 "view_cells_max_view_cells=",
 		 "0");
 
   
   RegisterOption("ViewCells.maxPvs",
-		 optInt,
-		 "-view_cells_max_pvs",
-		 "300");
+				 optInt,
+				 "view_cells_max_pvs=",
+				 "300");
 
   RegisterOption("ViewCells.PostProcess.minPvsDif",
-		 optInt,
-		 "-view_cells_post_process_min_pvs_dif",
-		 "10");
+				 optInt,
+				 "view_cells_post_process_min_pvs_dif=",
+				 "10");
 
   RegisterOption("ViewCells.PostProcess.maxPvs",
-		 optInt,
-		 "-view_cells_post_process_max_pvs",
-		 "300");
+				 optInt,
+				 "view_cells_post_process_max_pvs=",
+				 "300");
 
   RegisterOption("ViewCells.PostProcess.minPvs",
-		 optString,
-		 "-view_cells_post_process_min_pvs",
-		 "10");
-
+				 optString,
+				 "view_cells_post_process_min_pvs",
+				 "10");
+  
   RegisterOption("ViewCells.filename",
 		 optString,
-		 "-view_cells_filename=",
+		 "view_cells_filename=",
 		 "atlanta_viewcells_large.x3d");
 
    RegisterOption("ViewCells.height",
 		 optFloat,
-		 "-view_cells_height=",
+		 "view_cells_height=",
 		 "5.0");
 
@@ -1270,15 +1271,15 @@
   RegisterOption("Simulation.objRenderCost",
 		 optFloat,
-		 "-simulation_obj_render_cost",
+		 "simulation_obj_render_cost",
 		 "1.0");
 
   RegisterOption("Simulation.vcOverhead",
 		 optFloat,
-		 "-simulation_vc_overhead",
+		 "simulation_vc_overhead",
 		 "0.05");
 
   RegisterOption("Simulation.moveSpeed",
 		 optFloat,
-		 "-simulation_moveSpeed",
+		 "simulation_moveSpeed",
 		 "1.0");
 
@@ -1293,122 +1294,121 @@
   RegisterOption("BspTree.Construction.input",
 	  optString,
-	  "-bsp_construction_input=",
+	  "bsp_construction_input=",
 	  "fromViewCells");
   
   RegisterOption("BspTree.Construction.samples",
 	  optInt,
-	  "-bsp_construction_samples=",
+	  "bsp_construction_samples=",
 	  "100000");
 
   RegisterOption("BspTree.Construction.epsilon",
 	  optFloat,
-	  "-bsp_construction_side_tolerance=",
+	  "bsp_construction_side_tolerance=",
 	  "0.002");
 
   RegisterOption("BspTree.Termination.minPolygons",
 		 optInt,
-		 "-bsp_term_min_polygons=",
+		 "bsp_term_min_polygons=",
 		 "5");
 
   RegisterOption("BspTree.Termination.minPvs",
 		 optInt,
-		 "-bsp_term_min_pvs=",
+		 "bsp_term_min_pvs=",
 		 "20");
 
   RegisterOption("BspTree.Termination.minArea",
 		 optFloat,
-		 "-bsp_term_min_area=",
+		 "bsp_term_min_area=",
 		 "0.001");
   
   RegisterOption("BspTree.Termination.maxRayContribution",
 		 optFloat,
-		 "-bsp_term_ray_contribution=",
+		 "bsp_term_ray_contribution=",
 		 "0.005");
 
   RegisterOption("BspTree.Termination.minAccRayLenght",
 		 optFloat,
-		 "-bsp_term_min_acc_ray_length=",
+		 "bsp_term_min_acc_ray_length=",
 		 "50");
 
    RegisterOption("BspTree.Termination.minRays",
 		 optInt,
-		 "-bsp_term_min_rays=",
+		 "bsp_term_min_rays=",
 		 "-1");
 
    RegisterOption("BspTree.Termination.ct_div_ci",
 		 optFloat,
-		 "-bsp_term_ct_div_ci=",
+		 "bsp_term_ct_div_ci=",
 		 "0.0");
   
   RegisterOption("BspTree.Termination.maxDepth",
 		 optInt,
-		 "-bsp_term_max_depth=",
+		 "bsp_term_max_depth=",
 		 "100");
 
   RegisterOption("BspTree.Termination.maxCostRatio",
 		 optFloat,
-		 "-bsp_term_axis_aligned_max_cost_ratio=",
+		 "bsp_term_axis_aligned_max_cost_ratio=",
 		 "1.5");
 
   RegisterOption("BspTree.Termination.AxisAligned.ct_div_ci",
 		 optFloat,
-		 "-bsp_term_axis_aligned_ct_div_ci=",
+		 "bsp_term_axis_aligned_ct_div_ci=",
 		 "0.5");
 
   RegisterOption("BspTree.AxisAligned.splitBorder",
 		 optFloat,
-		 "-bsp__axis_aligned_split_border=",
+		 "bsp__axis_aligned_split_border=",
 		 "0.1");
 
   RegisterOption("BspTree.Termination.AxisAligned.minPolys",
 		 optInt,
-		 "-bsp_term_axis_aligned_max_polygons=",
+		 "bsp_term_axis_aligned_max_polygons=",
 		 "50");
 
    RegisterOption("BspTree.Termination.AxisAligned.minObjects",
 		 optInt,
-		 "-bsp_term_min_objects=",
+		 "bsp_term_min_objects=",
 		 "3");
 
   RegisterOption("BspTree.Termination.AxisAligned.minRays",
 		 optInt,
-		 "-bsp_term_axis_aligned_min_rays=",
+		 "bsp_term_axis_aligned_min_rays=",
 		 "-1");
 
   RegisterOption("BspTree.splitPlaneStrategy",
 		 optString,
-		 "-bsp_split_method=",
+		 "bsp_split_method=",
 		 "leastSplits");
 
   RegisterOption("BspTree.maxPolyCandidates",
 	  optInt,
-	  "-bsp_max_poly_candidates=",
+	  "bsp_max_poly_candidates=",
 	  "20");
 
   RegisterOption("BspTree.maxRayCandidates",
 	  optInt,
-	  "-bsp_max_plane_candidates=",
+	  "bsp_max_plane_candidates=",
 	  "20");
 
   RegisterOption("BspTree.maxTests",
 	  optInt,
-	  "-bsp_max_tests=",
+	  "bsp_max_tests=",
 	  "5000");
 
   RegisterOption("BspTree.Visualization.exportSplits",
 	  optBool,
-	  "-bsp_visualization.export_splits",
+	  "bsp_visualization.export_splits",
 	  "false");
 
-
-   RegisterOption("BspTree.Factor.verticalSplits", optFloat, "-bsp_factor_vertical=", "1.0");
-   RegisterOption("BspTree.Factor.largestPolyArea", optFloat, "-bsp_factor_largest_poly=", "1.0");
-   RegisterOption("BspTree.Factor.blockedRays", optFloat, "-bsp_factor_blocked=", "1.0");
-   RegisterOption("BspTree.Factor.leastSplits", optFloat, "-bsp_factor_least_splits=", "1.0");
-   RegisterOption("BspTree.Factor.balancedPolys", optFloat, "-bsp_factor_balanced_polys=", "1.0");
-   RegisterOption("BspTree.Factor.balancedViewCells", optFloat, "-bsp_factor_balanced_view_cells=", "1.0");
-   RegisterOption("BspTree.Factor.leastRaySplits", optFloat, "-bsp_factor_least_ray_splits=", "1.0");
-   RegisterOption("BspTree.Factor.balancedRays", optFloat, "-bsp_factor_balanced_rays=", "1.0");
-   RegisterOption("BspTree.Factor.pvs", optFloat, "-bsp_factor_pvs=", "1.0");
+  RegisterOption("BspTree.Factor.verticalSplits", optFloat, "bsp_factor_vertical=", "1.0");
+   RegisterOption("BspTree.Factor.largestPolyArea", optFloat, "bsp_factor_largest_poly=", "1.0");
+   RegisterOption("BspTree.Factor.blockedRays", optFloat, "bsp_factor_blocked=", "1.0");
+   RegisterOption("BspTree.Factor.leastSplits", optFloat, "bsp_factor_least_splits=", "1.0");
+   RegisterOption("BspTree.Factor.balancedPolys", optFloat, "bsp_factor_balanced_polys=", "1.0");
+   RegisterOption("BspTree.Factor.balancedViewCells", optFloat, "bsp_factor_balanced_view_cells=", "1.0");
+   RegisterOption("BspTree.Factor.leastRaySplits", optFloat, "bsp_factor_least_ray_splits=", "1.0");
+   RegisterOption("BspTree.Factor.balancedRays", optFloat, "bsp_factor_balanced_rays=", "1.0");
+   RegisterOption("BspTree.Factor.pvs", optFloat, "bsp_factor_pvs=", "1.0");
 
    /************************************************************************************/
@@ -1418,5 +1418,5 @@
    RegisterOption("Preprocessor.type",
 				 optString,
-				 "-preprocessor=",
+				 "preprocessor=",
 				 "sampling");
 
@@ -1426,12 +1426,17 @@
 				  "rays.out");
 
-   /**************************************************************************************/
-   /*                  View space partition KD tree related options                      */
-   /**************************************************************************************/
+  RegisterOption("Preprocessor.useGlRenderer",
+				 optBool,
+				 "useGlRenderer",
+				 "false");
+  
+  /**************************************************************************************/
+  /*                  View space partition KD tree related options                      */
+  /**************************************************************************************/
 
    RegisterOption("VspKdTree.Construction.samples",
-	   optInt,
-	   "-vsp_kd_construction_samples=",
-	   "100000");
+				  optInt,
+				  "vsp_kd_construction_samples=",
+				  "100000");
 
    RegisterOption("VspKdTree.Termination.maxDepth", 
@@ -1525,5 +1530,5 @@
 	RegisterOption("VspKdTree.PostProcess.maxCostRatio",
 			optFloat,
-			"-vsp_kd_post_process_max_cost_ratio=",
+			"vsp_kd_post_process_max_cost_ratio=",
 			"0.9");
 
@@ -1568,4 +1573,5 @@
 	RegisterOption("VssTree.queryType", optString, "qtype=", "static");
 
+
 	RegisterOption("VssTree.queryPosWeight", optFloat, "qposweight=", "0.0");
 	RegisterOption("VssTree.useRefDirSplits", optBool, "refdir", "false");
@@ -1581,27 +1587,37 @@
 	RegisterOption("RssPreprocessor.initialSamples",
 									optInt,
-									"-initial_samples=",
+									"initial_samples=",
 									"100000");
 
 	RegisterOption("RssPreprocessor.vssSamples",
-									optInt,
-									"-vss_samples=",
-									"1000000");
-
+				   optInt,
+				   "rss_vss_samples=",
+				   "1000000");
+	
 	RegisterOption("RssPreprocessor.vssSamplesPerPass",
-									optInt,
-									"-vss_samples_per_pass=",
-									"1000");
-
-		RegisterOption("RssPreprocessor.samplesPerPass",
-									optInt,
-									"-samples_per_pass=",
-									"100000");
-
+				   optInt,
+				   "rss_vss_samples_per_pass=",
+				   "1000");
+	
+	RegisterOption("RssPreprocessor.samplesPerPass",
+				   optInt,
+				   "rss_samples_per_pass=",
+				   "100000");
+	
 	RegisterOption("RssPreprocessor.useImportanceSampling",
-									optBool,
-									"-vss_use_importance=",
-									"true");
-
+				   optBool,
+				   "rss_use_importance",
+				   "true");
+	
+	RegisterOption("RssPreprocessor.objectBasedSampling",
+				   optBool,
+				   "rss_object_based_sampling",
+				   "true");
+	
+	RegisterOption("RssPreprocessor.directionalSampling",
+				   optBool,
+				   "rss_directional_sampling",
+				   "false");
+	
 	RegisterOption("RssTree.maxDepth", optInt, "kd_depth=", "12");
 	RegisterOption("RssTree.minPvs", optInt, "kd_minpvs=", "1");
@@ -1609,5 +1625,5 @@
 	RegisterOption("RssTree.maxCostRatio", optFloat, "maxcost=", "0.95");
 	RegisterOption("RssTree.maxRayContribution", optFloat, "maxraycontrib=", "0.5");
-
+	
 	RegisterOption("RssTree.epsilon", optFloat, "kd_eps=", "1e-6");
 	RegisterOption("RssTree.ct_div_ci", optFloat, "kd_ctdivci=", "1.0");
@@ -1615,14 +1631,14 @@
 	RegisterOption("RssTree.splitType", optString, "split=", "queries");
 	RegisterOption("RssTree.splitUseOnlyDrivingAxis", optBool, "splitdriving=", "false");
-
+	
 	RegisterOption("RssTree.numberOfEndPointDomains", optInt, "endpoints=", "10000");
-
+	
 	RegisterOption("RssTree.minSize", optFloat, "minsize=", "0.001");
-
+	
 	RegisterOption("RssTree.maxTotalMemory", optFloat, "mem=", "60.0");
 	RegisterOption("RssTree.maxStaticMemory", optFloat, "statmem=", "8.0");
-
+	
 	RegisterOption("RssTree.queryType", optString, "qtype=", "static");
-
+	
 	RegisterOption("RssTree.queryPosWeight", optFloat, "qposweight=", "0.0");
 	RegisterOption("RssTree.useRefDirSplits", optBool, "refdir", "false");
@@ -1631,8 +1647,10 @@
 	RegisterOption("RssTree.accessTimeThreshold", optInt, "accesstime=", "1000");
 	RegisterOption("RssTree.minCollapseDepth", optInt, "colldepth=", "4");
-
+	
 	RegisterOption("RssTree.interleaveDirSplits", optBool, "interleavedirsplits", "true");
 	RegisterOption("RssTree.dirSplitDepth", optInt, "dirsplidepth=", "10");
-
+	RegisterOption("RssTree.importanceBasedCost", optBool, "importance_based_cost", "true");
+	RegisterOption("RssTree.maxRays", optInt, "rss_max_rays=", "2000000");
+	
 	RegisterOption("RssPreprocessor.Export.pvs", optBool, "rss_export_pvs", "false");
 	RegisterOption("RssPreprocessor.Export.rssTree", optBool, "rss_export_rss_tree", "false");
@@ -1641,58 +1659,62 @@
 	RegisterOption("RssPreprocessor.useViewcells", optBool, "rss_use_viewcells", "false");
 	RegisterOption("RssPreprocessor.updateSubdivision", optBool, "rss_update_subdivision", "false");
+	
+	
+  /************************************************************************************/
+  /*               View space partition BSP tree related options                      */
+  /************************************************************************************/
+
 
 	RegisterOption("RssPreprocessor.loadInitialSamples",
-	  optBool,
-	  "-vss_load_loadInitialSamples=",
-	  "false");
+				   optBool,
+				   "vss_load_loadInitialSamples=",
+				   "false");
 
 	RegisterOption("RssPreprocessor.storeInitialSamples",
-	  optBool,
-	  "-vss_store_storeInitialSamples=",
-	  "false");
+				   optBool,
+				   "vss_store_storeInitialSamples=",
+				   "false");
 
 	/************************************************************************************/
 	/*               View space partition BSP tree related options                      */
 	/************************************************************************************/
-
 	RegisterOption("VspBspTree.Termination.minPolygons",
-		optInt,
-		"-vsp_bsp_term_min_polygons=",
-		"5");
+				   optInt,
+				   "vsp_bsp_term_min_polygons=",
+				   "5");
 
 	RegisterOption("VspBspTree.Termination.minPvs",
-		optInt,
-		"-vsp_bsp_term_min_pvs=",
-		"20");
-
+				   optInt,
+				   "vsp_bsp_term_min_pvs=",
+				   "20");
 	RegisterOption("VspBspTree.Termination.minArea",
-		optFloat,
-		"-vsp_bsp_term_min_area=",
-		"0.001");
+				   optFloat,
+				   "vsp_bsp_term_min_area=",
+				   "0.001");
 
 	RegisterOption("VspBspTree.Termination.maxRayContribution",
-		optFloat,
-		"-vsp_bsp_term_ray_contribution=",
-		"0.005");
+				   optFloat,
+				   "vsp_bsp_term_ray_contribution=",
+				   "0.005");
 
 	RegisterOption("VspBspTree.Termination.minAccRayLenght",
-		optFloat,
-		"-vsp_bsp_term_min_acc_ray_length=",
-		"50");
+				   optFloat,
+				   "vsp_bsp_term_min_acc_ray_length=",
+				   "50");
 
 	RegisterOption("VspBspTree.Termination.minRays",
-		optInt,
-		"-vsp_bsp_term_min_rays=",
-		"-1");
+				   optInt,
+				   "vsp_bsp_term_min_rays=",
+				   "-1");
 
 	RegisterOption("VspBspTree.Termination.ct_div_ci",
-		optFloat,
-		"-vsp_bsp_term_ct_div_ci=",
-		"0.0");
+				   optFloat,
+				   "vsp_bsp_term_ct_div_ci=",
+				   "0.0");
 
 	RegisterOption("VspBspTree.Termination.maxDepth",
-		optInt,
-		"-vsp_bsp_term_max_depth=",
-		"100");
+				   optInt,
+				   "vsp_bsp_term_max_depth=",
+				   "100");
 
 	RegisterOption("VspBspTree.Termination.AxisAligned.maxCostRatio",
@@ -1712,49 +1734,46 @@
 
 	RegisterOption("VspBspTree.Termination.missTolerance",
-		 optInt,
-		 "-vsp_bsp_term_miss_tolerance=",
-		 "4");
-
+				   optInt,
+				   "vsp_bsp_term_miss_tolerance=",
+				   "4");
 	RegisterOption("VspBspTree.splitPlaneStrategy",
-			optString,
-			"-vsp_bsp_split_method=",
-			"leastSplits");
+				   optString,
+				   "vsp_bsp_split_method=",
+				   "leastSplits");
 
 	RegisterOption("VspBspTree.maxPolyCandidates",
-		optInt,
-		"-vsp_bsp_max_poly_candidates=",
-		"20");
-
+				   optInt,
+				   "vsp_bsp_max_poly_candidates=",
+				   "20");
 	RegisterOption("VspBspTree.maxRayCandidates",
-		optInt,
-		"-vsp_bsp_max_plane_candidates=",
-		"20");
+				   optInt,
+				   "vsp_bsp_max_plane_candidates=",
+				   "20");
 
 	RegisterOption("VspBspTree.maxTests",
-		optInt,
-		"-vsp_bsp_max_tests=",
-		"5000");
+				   optInt,
+				   "vsp_bsp_max_tests=",
+				   "5000");
 
 	RegisterOption("VspBspTree.Construction.samples",
-		optInt,
-		"-bsp_construction_samples=",
-		"100000");
+				   optInt,
+				   "bsp_construction_samples=",
+				   "100000");
 
 	RegisterOption("VspBspTree.Construction.epsilon",
-		optFloat,
-		"-vsp_bsp_construction_side_tolerance=",
-		"0.002");
+				   optFloat,
+				   "vsp_bsp_construction_side_tolerance=",
+				   "0.002");
 
 	RegisterOption("VspBspTree.Visualization.exportSplits",
-		optBool,
-		"-vsp_bsp_visualization.export_splits",
-		"false");
+				   optBool,
+				   "vsp_bsp_visualization.export_splits",
+				   "false");
 	
 	RegisterOption("VspBspTree.splitUseOnlyDrivingAxis", 
-		optBool, 
-		"vsp_bsp_splitdriving=", 
-		"false");
-
-
+				   optBool, 
+				   "vsp_bsp_splitdriving=", 
+				   "false");
+	
 	RegisterOption("VspBspTree.Factor.leastRaySplits", optFloat, "-vsp_bsp_factor_least_ray_splits=", "1.0");
 	RegisterOption("VspBspTree.Factor.balancedRays", optFloat, "-vsp_bsp_factor_balanced_rays=", "1.0");
@@ -1801,5 +1820,5 @@
 
 void
-Environment::Parse(const int argc, const char *argv[], bool useExePath)
+Environment::Parse(const int argc, char **argv, bool useExePath)
 {
   
Index: trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp	(revision 491)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp	(revision 492)
@@ -2672,4 +2672,35 @@
 }
 
+
+ViewCell *
+BspTree::GetViewCell(const Vector3 &point)
+{
+  stack<BspNode *> nodeStack;
+  nodeStack.push(mRoot);
+  
+  ViewCell *viewcell = NULL;
+  
+  while (!nodeStack.empty())  {
+	BspNode *node = nodeStack.top();
+	nodeStack.pop();
+	
+	if (node->IsLeaf()) {
+	  viewcell = dynamic_cast<BspLeaf *>(node)->mViewCell;
+	  break;
+	} else {
+	  
+	  BspInterior *interior = dynamic_cast<BspInterior *>(node);
+		
+	  // random decision
+	  if (interior->GetPlane().Side(point) < 0)
+		nodeStack.push(interior->GetBack());
+	  else
+		nodeStack.push(interior->GetFront());
+	}
+  }
+  
+  return viewcell;
+}
+
 void BspNodeGeometry::ComputeBoundingBox(AxisAlignedBox3 &box)
 {
Index: trunk/VUT/GtpVisibilityPreprocessor/src/SceneGraph.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/SceneGraph.cpp	(revision 490)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/SceneGraph.cpp	(revision 492)
@@ -5,5 +5,4 @@
 #include "X3dExporter.h"
 #include "Intersectable.h"
-
 
 
@@ -104,2 +103,23 @@
 	
 }
+
+
+void
+SceneGraphNode::UpdateBox()
+{
+  AxisAlignedBox3 box;
+  
+  box.Initialize();
+  
+  ObjectContainer::const_iterator mi = mGeometry.begin();
+  for (; mi != mGeometry.end(); mi++)
+	box.Include((*mi)->GetBox());
+  
+  SceneGraphNodeContainer::iterator ni = mChildren.begin();
+  for (; ni != mChildren.end(); ni++) {
+	(*ni)->UpdateBox();
+	box.Include((*ni)->mBox);
+  }
+  
+  mBox = box;
+}
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Vector3.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Vector3.cpp	(revision 448)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Vector3.cpp	(revision 492)
@@ -191,40 +191,62 @@
 
 Vector3
-UniformRandomVector(const Vector3 &normal)
-{
-	//  float r1 = RandomValue(0.0f, 1.0f);
-	//  float r2 = RandomValue(0.0f, 1.0f);
-	float r1, r2;
+UniformRandomVector()
+{
+  //  float r1 = RandomValue(0.0f, 1.0f);
+  //  float r2 = RandomValue(0.0f, 1.0f);
+  float r1, r2;
 	
-	halton2.GetNext(r1, r2);
+  halton2.GetNext(r1, r2);
 	
 	
-	float cosTheta = 1.0f - r1;
+  float cosTheta = 1.0f - 2*r1;
   float sinTheta = sqrt(1 - sqr(cosTheta));
   float fi = 2.0f*M_PI*r2;
   
   Vector3 dir(sinTheta*sin(fi),
-							cosTheta,
-							sinTheta*cos(fi));
-	
+			  cosTheta,
+			  sinTheta*cos(fi));
+  
+  return dir;
+}
+
+Vector3
+UniformRandomVector(const Vector3 &normal)
+{
+  //  float r1 = RandomValue(0.0f, 1.0f);
+  //  float r2 = RandomValue(0.0f, 1.0f);
+  float r1, r2;
+  
+  halton2.GetNext(r1, r2);
+  
+  
+  float cosTheta = 1.0f - r1;
+  float sinTheta = sqrt(1 - sqr(cosTheta));
+  float fi = 2.0f*M_PI*r2;
+  
+  Vector3 dir(sinTheta*sin(fi),
+			  cosTheta,
+			  sinTheta*cos(fi));
+  
   
   //  return Normalize(dir);
-	
+  
   Matrix4x4 m = RotationVectorsMatrix(
-																			normal,
-																			Vector3(0,1,0));
+									  normal,
+									  Vector3(0,1,0));
   Matrix4x4 mi = Invert(m);
   m = m*RotationVectorsMatrix(
-															Vector3(0,1,0),
-															Normalize(dir))*mi;
+							  Vector3(0,1,0),
+							  Normalize(dir))*mi;
   
   return TransformNormal(m, normal);
   
-	//    return TransformNormal(
-	//  			 RotationVectorsMatrix(
-	//  					       Vector3(0,1,0),
-	//  					       Normalize(dir)
-	//  					       ),
-	//  			 normal
-	//  			 );
-}
+  //    return TransformNormal(
+  //  			 RotationVectorsMatrix(
+  //  					       Vector3(0,1,0),
+  //  					       Normalize(dir)
+  //  					       ),
+  //  			 normal
+  //  			 );
+}
+
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Halton.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Halton.cpp	(revision 355)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Halton.cpp	(revision 492)
@@ -5,2 +5,3 @@
 
 Halton2 halton2;
+float Halton2::_invBases[2];
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.cpp	(revision 491)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.cpp	(revision 492)
@@ -12,4 +12,6 @@
 #include "RenderSimulator.h"
 
+Preprocessor *preprocessor;
+
 Preprocessor::Preprocessor():
 mKdTree(NULL),
@@ -19,4 +21,5 @@
 mViewCellsManager(NULL)
 {
+  environment->GetBoolValue("Preprocessor.useGlRenderer", mUseGlRenderer);
 }
 
@@ -55,5 +58,4 @@
 
   mSceneGraph = new SceneGraph;
-
   
   Parser *parser;
@@ -95,14 +97,17 @@
 
 	if (result) {
-		mSceneGraph->AssignObjectIds();
-		int intersectables, faces;
-		mSceneGraph->GetStatistics(intersectables, faces);
-		cout<<filename<<" parsed successfully."<<endl;
-		cout<<"#NUM_OBJECTS (Total numner of objects)\n"<<intersectables<<endl;
-		cout<<"#NUM_FACES (Total numner of faces)\n"<<faces<<endl;
-	}
-
-	
-  return result;
+	  
+	  mSceneGraph->AssignObjectIds();
+	  int intersectables, faces;
+	  mSceneGraph->GetStatistics(intersectables, faces);
+	  cout<<filename<<" parsed successfully."<<endl;
+	  cout<<"#NUM_OBJECTS (Total numner of objects)\n"<<intersectables<<endl;
+	  cout<<"#NUM_FACES (Total numner of faces)\n"<<faces<<endl;
+	  mSceneGraph->CollectObjects(&mObjects);
+	  mSceneGraph->mRoot->UpdateBox();
+	}
+	
+	
+	return result;
 }
 
@@ -139,8 +144,8 @@
 bool
 Preprocessor::Export( const string filename,
-											const bool scene,
-											const bool kdtree,
-											const bool bsptree
-											)
+					  const bool scene,
+					  const bool kdtree,
+					  const bool bsptree
+					  )
 {
   Exporter *exporter = Exporter::GetExporter(filename);
